Package org.optaplanner.core.impl.heuristic

## Class HeuristicConfigPolicy<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.heuristic.HeuristicConfigPolicy<Solution_>

-     public class HeuristicConfigPolicy<Solution_>
      extends Object

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HeuristicConfigPolicy​(EnvironmentMode environmentMode, Integer moveThreadCount, Integer moveThreadBufferSize, Class<? extends ThreadFactory> threadFactoryClass, InnerScoreDirectorFactory<Solution_,​?> scoreDirectorFactory)` |
    `HeuristicConfigPolicy​(EnvironmentMode environmentMode, String logIndentation, Integer moveThreadCount, Integer moveThreadBufferSize, Class<? extends ThreadFactory> threadFactoryClass, InnerScoreDirectorFactory<Solution_,​?> scoreDirectorFactory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addEntityMimicRecorder​(String id, EntityMimicRecorder<Solution_> mimicRecordingEntitySelector)` |
    `void` | `addValueMimicRecorder​(String id, ValueMimicRecorder<Solution_> mimicRecordingValueSelector)` |
    `ThreadFactory` | `buildThreadFactory​(ChildThreadType childThreadType)` |
    `HeuristicConfigPolicy<Solution_>` | `createChildThreadConfigPolicy​(ChildThreadType childThreadType)` |
    `HeuristicConfigPolicy<Solution_>` | `createFilteredPhaseConfigPolicy()` |
    `HeuristicConfigPolicy<Solution_>` | `createPhaseConfigPolicy()` |
    `EntityMimicRecorder<Solution_>` | `getEntityMimicRecorder​(String id)` |
    `Map<String,​EntityMimicRecorder<Solution_>>` | `getEntityMimicRecorderMap()` |
    `EntitySorterManner` | `getEntitySorterManner()` |
    `EnvironmentMode` | `getEnvironmentMode()` |
    `String` | `getLogIndentation()` |
    `Integer` | `getMoveThreadBufferSize()` |
    `Integer` | `getMoveThreadCount()` |
    `ScoreDefinition` | `getScoreDefinition()` |
    `InnerScoreDirectorFactory<Solution_,​?>` | `getScoreDirectorFactory()` |
    `SolutionDescriptor<Solution_>` | `getSolutionDescriptor()` |
    `Class<? extends ThreadFactory>` | `getThreadFactoryClass()` |
    `ValueMimicRecorder<Solution_>` | `getValueMimicRecorder​(String id)` |
    `Map<String,​ValueMimicRecorder<Solution_>>` | `getValueMimicRecorderMap()` |
    `ValueSorterManner` | `getValueSorterManner()` |
    `boolean` | `isInitializedChainedValueFilterEnabled()` |
    `boolean` | `isReinitializeVariableFilterEnabled()` |
    `void` | `setEntityMimicRecorderMap​(Map<String,​EntityMimicRecorder<Solution_>> entityMimicRecorderMap)` |
    `void` | `setEntitySorterManner​(EntitySorterManner entitySorterManner)` |
    `void` | `setValueMimicRecorderMap​(Map<String,​ValueMimicRecorder<Solution_>> valueMimicRecorderMap)` |
    `void` | `setValueSorterManner​(ValueSorterManner valueSorterManner)` |
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### HeuristicConfigPolicy

          public HeuristicConfigPolicy​(EnvironmentMode environmentMode,
                                       Integer moveThreadCount,
                                       Integer moveThreadBufferSize,
                                       Class<? extends ThreadFactory> threadFactoryClass,
                                       InnerScoreDirectorFactory<Solution_,​?> scoreDirectorFactory)

    - #### HeuristicConfigPolicy

          public HeuristicConfigPolicy​(EnvironmentMode environmentMode,
                                       String logIndentation,
                                       Integer moveThreadCount,
                                       Integer moveThreadBufferSize,
                                       Class<? extends ThreadFactory> threadFactoryClass,
                                       InnerScoreDirectorFactory<Solution_,​?> scoreDirectorFactory)

  - ### Method Detail

    - #### getEnvironmentMode

          public EnvironmentMode getEnvironmentMode()

    - #### getLogIndentation

          public String getLogIndentation()

    - #### getMoveThreadCount

          public Integer getMoveThreadCount()

    - #### getThreadFactoryClass

          public Class<? extends ThreadFactory> getThreadFactoryClass()

    - #### getMoveThreadBufferSize

          public Integer getMoveThreadBufferSize()

    - #### getSolutionDescriptor

          public SolutionDescriptor<Solution_> getSolutionDescriptor()

    - #### getScoreDefinition

          public ScoreDefinition getScoreDefinition()

    - #### getScoreDirectorFactory

          public InnerScoreDirectorFactory<Solution_,​?> getScoreDirectorFactory()

    - #### getEntitySorterManner

          public EntitySorterManner getEntitySorterManner()

    - #### setEntitySorterManner

          public void setEntitySorterManner​(EntitySorterManner entitySorterManner)

    - #### getValueSorterManner

          public ValueSorterManner getValueSorterManner()

    - #### setValueSorterManner

          public void setValueSorterManner​(ValueSorterManner valueSorterManner)

    - #### isReinitializeVariableFilterEnabled

          public boolean isReinitializeVariableFilterEnabled()

    - #### getEntityMimicRecorderMap

          public Map<String,​EntityMimicRecorder<Solution_>> getEntityMimicRecorderMap()

    - #### setEntityMimicRecorderMap

          public void setEntityMimicRecorderMap​(Map<String,​EntityMimicRecorder<Solution_>> entityMimicRecorderMap)

    - #### getValueMimicRecorderMap

          public Map<String,​ValueMimicRecorder<Solution_>> getValueMimicRecorderMap()

    - #### setValueMimicRecorderMap

          public void setValueMimicRecorderMap​(Map<String,​ValueMimicRecorder<Solution_>> valueMimicRecorderMap)

    - #### isInitializedChainedValueFilterEnabled

          public boolean isInitializedChainedValueFilterEnabled()

    - #### createPhaseConfigPolicy

          public HeuristicConfigPolicy<Solution_> createPhaseConfigPolicy()

    - #### createFilteredPhaseConfigPolicy

          public HeuristicConfigPolicy<Solution_> createFilteredPhaseConfigPolicy()

    - #### createChildThreadConfigPolicy

          public HeuristicConfigPolicy<Solution_> createChildThreadConfigPolicy​(ChildThreadType childThreadType)

    - #### addEntityMimicRecorder

          public void addEntityMimicRecorder​(String id,
                                             EntityMimicRecorder<Solution_> mimicRecordingEntitySelector)

    - #### getEntityMimicRecorder

          public EntityMimicRecorder<Solution_> getEntityMimicRecorder​(String id)

    - #### addValueMimicRecorder

          public void addValueMimicRecorder​(String id,
                                            ValueMimicRecorder<Solution_> mimicRecordingValueSelector)

    - #### getValueMimicRecorder

          public ValueMimicRecorder<Solution_> getValueMimicRecorder​(String id)

    - #### buildThreadFactory

          public ThreadFactory buildThreadFactory​(ChildThreadType childThreadType)

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`